#include "stdafx.h"
#include "cv.h"
#include "cvaux.h"
//#include "cxcore.h"
#include "highgui.h"
//#include "cvcam.h"
#include <stdio.h>
#include "darioBD.h"
#include "cvtypes.h"

//struct CvContourScanner { };

// Costruttore
darioBD::darioBD() {
	mMaxNumber = 30;	//!< (configuration) The maximum number of blobs that are to detect.

	mMinArea = 10;	//!< (configuration) The minimum area of a blob.
	mMaxArea = 50000;	//!< (configuration) The maximum area of a blob.
	mAreaSelection = true; //!< (configuration) If the selection is based on the blob area

	mMinCompactness = 0;	//!< (configuration) The minimum Compactness of a blob.
	mMaxCompactness = 1;	//!< (configuration) The maximum Compactness of a blob.
	mCompactnessSelection = false; //!< (configuration) If the selection is based on the blob Compactness

	mMinOrientation = 0;	//!< (configuration) The minimum Compactness of a blob.
	mMaxOrientation  = 1;	//!< (configuration) The maximum Compactness of a blob.
	mOrientationSelection = false; //!< (configuration) If the selection is based on the blob Orientation

}

darioBD::~darioBD() {
	// Boh anche qui
}

IplImage* darioBD::disegnaBlob(IplImage* pImg) {
	IplImage* risultato = cvCloneImage(pImg);


	// Get and check input image
//	IplImage *inputimage = cvCloneImage(mCore->mDataStructureImageBinary.mImage);
//	IplImage *outputImage = mCore->mDataStructureImageBinary.mImage;

//	if (! inputimage) {
//		AddError("No input image.");
//		return;
//	}
//	if (inputimage->nChannels != 1) {
//		return;
//	}

	// Pulisco l'immagine risultato
	cvZero(risultato);

	CvMoments moments; // Used to calculate the moments

	// We allocate memory to extract the contours from the binary image
	CvMemStorage* storage = cvCreateMemStorage(0);
	CvSeq* contour = 0;
	
	
	// Init blob extraxtion
	_CvContourScanner* blobs = cvStartFindContours(pImg,storage,sizeof(CvContour),CV_RETR_LIST,CV_CHAIN_APPROX_NONE);

	// This is used to correct the position in case of ROI
	CvRect rectROI;
	rectROI.x = 0;
	rectROI.y = 0;

	while ((contour=cvFindNextContour(blobs))!=NULL) {

		// Presi pari pari da Particle.h
		
		CvPoint2D32f mCenter;	//!< Particle center [pixels].
		float mOrientation;		//!< The orientation angle of the particle [rad].
		double mArea;			//!< Particle area [pixels^2].
		double mCompactness;	//!< The contour's compactness (area/circumference ratio).


		// Computing the moments
		cvMoments(contour, &moments);

		// Computing particle area
		mArea=moments.m00;
		mCenter.x=(float)(rectROI.x + (moments.m10/moments.m00+0.5));  // moments using Green theorem
		mCenter.y=(float)(rectROI.y + (moments.m01/moments.m00+0.5));  // m10 = x direction, m01 = y direction, m00 = area as edicted in theorem
		
		// Selection based on area
		if ((mAreaSelection==false)||((mArea<=mMaxArea) && (mArea>=mMinArea)))
		{
			mCompactness=GetContourCompactness(contour);
			if ((mCompactnessSelection==false)||((mCompactness>mMinCompactness) && (mCompactness<mMaxCompactness)))
			{
				double tempValue=cvGetCentralMoment(&moments,2,0)-cvGetCentralMoment(&moments,0,2);
				mOrientation=atan(2*cvGetCentralMoment(&moments,1,1)/(tempValue+sqrt(tempValue*tempValue+4*cvGetCentralMoment(&moments,1,1)*cvGetCentralMoment(&moments,1,1))));
				if ((mOrientationSelection==false)||(((mOrientation>mMinOrientation)&&(mOrientation<mMaxOrientation))||((mOrientation>mMinOrientation+PI)&&(mOrientation<mMaxOrientation+PI))||((mOrientation>mMinOrientation-PI)&&(mOrientation<mMaxOrientation-PI))))
				{
					cvDrawContours(risultato,contour,cvScalarAll(255),cvScalarAll(255),0,CV_FILLED);
				}
			}
		} 
		else 
		{
			//rejectedparticles.push_back(tmpParticle);
		}
		cvRelease((void**)&contour);
	}
	contour = cvEndFindContours(&blobs);


	cvReleaseImage(&pImg);
	cvRelease((void**)&contour);
	cvReleaseMemStorage(&storage);


	return risultato;

}

double darioBD::GetContourCompactness(const void* contour) {
	double l = cvArcLength(contour, CV_WHOLE_SEQ, 1);
	return fabs(12.56*cvContourArea(contour)/(l*l));	
}
