// File di progetto principale per i progetti applicazioni VC++ 
// generati tramite una creazione guidata applicazione.

#include "stdafx.h"
#include "cv.h"
#include "cvaux.h"
//#include "cxcore.h"
#include "highgui.h"
//#include "cvcam.h"
#include <stdio.h>
#include "darioblob.h"


#using <mscorlib.dll>

using namespace System;


// Se definisco SOGLIA, c' la finestra con threshold, erosione ETC.
//#define SOGLIA

struct CvCapture { };

//class CvContourScanner { };


void scriviEvento(char* stringa) {
	printf("Ricevuto evento: %s\n", stringa);
}


int main(int argc, char* argv[])
{
	// Variabili
	CvCapture* pCap = NULL;

	darioblob* tracker = NULL;

	// Creo il dispositivo di Capture dalla camera
	pCap = cvCaptureFromCAM( CV_CAP_ANY );

	// Se nonesiste, tutti a casa
	if( !pCap ) {
		fprintf( stderr, "ERRORE: non esiste dispositivo di cattura!\n" );
		getchar();
		return -1;
	}

	// Creo le finestre
	cvNamedWindow("mywindow", CV_WINDOW_AUTOSIZE ); // Finestra principale del blob tracking
	cvNamedWindow("finestrablob", CV_WINDOW_AUTOSIZE); // Finestra su cui disegno i blob

	IplImage* frame = NULL;
	// viene riempita con l'immagine che viene da RunBlobTrackingAuto
	IplImage* nuevaImago = NULL;
	IplImage* immagineBD = NULL;

	// flag del ciclo principale
	bool run = true;

	// flag del BlobTracking
	bool track = false;



  while(run) {
		// Prendo un frame dalla camera
		frame = cvQueryFrame( pCap );
		if( !frame ) {
			fprintf( stderr, "ERROR: frame is null...\n" );
			getchar();
			break;
		}

		// Mostro il frame in una finestra
		cvShowImage("mywindow", frame);

		if (track) {
			// Eseguo la pipeline

			nuevaImago = cvCloneImage(frame);
			nuevaImago = tracker->process(frame);

			// Flippo l'immagine, perch viene processata all'incontrario...
			cvFlip(nuevaImago);

			// Mostro il frame nella finestra
			cvShowImage( "finestrablob", nuevaImago /*frame*/ );

			// Rilascio l'immagine
			cvReleaseImage(&nuevaImago);

		}


    //If ESC key pressed, Key=0x10001B under OpenCV 0.9.7(linux version),
    //remove higher bits using AND operator

		int tasto = cvWaitKey(10); // & 255;

		//printf("tasto = %d\n", tasto);

		// Se si preme il tasto ESC, fine del ciclo
		if ((tasto & 255)== 27 ) {
			run = false;
		}

		// Se premo spazio, avvio il BlobTracker
		if ((tasto & 255) == 32) {
			if (!track) {
				// Istanzio il tracker
				tracker = new darioblob (frame, &scriviEvento);

				if (tracker != NULL) {
					cvCreateTrackbar("soglia", "finestrablob", &tracker -> valSoglia, 255, NULL);
					cvCreateTrackbar("max soglia", "finestrablob", &tracker -> maxSoglia, 255, NULL);
					cvCreateTrackbar("valDilate", "finestrablob", &tracker -> valDilate, 50, NULL);
					cvCreateTrackbar("valErode", "finestrablob", &tracker -> valErode, 50, NULL);
					
					
					//printf("Si detector...\n");
				} else {
					printf("No tracker...:(\n");
				}

				
				track = true;
			} else {
				if (tracker != NULL) {
					// Catturo un nuovo frame e lo passo al detector come sfondo
					tracker->updateSfondo(frame);
				}
			}
		}

		if ((tasto & 255) == 13) {
			if (tracker != NULL) {
				bloblist* ukulele = tracker->getLista();
				printf("ukulele->getTotale() = %d\n", ukulele->getTotale());
				for (int i = 0; i < ukulele->getTotale(); i ++) {
					DvBlob* trovato = ukulele->getBlob(i);
					printf("Blob %d:\n", i);
					printf(" ID = %d\n", trovato->ID);
					printf(" x = %f\n", trovato->x);
					printf(" y = %f\n", trovato->y);
					printf(" w = %f\n", trovato->w);
					printf(" h = %f\n", trovato->h);
				}
			}
		}


	} // Fine del ciclo WHILE

  // Rilascio tutto quanto
	
	cvReleaseCapture( &pCap );

	cvDestroyWindow( "mywindow" );
	cvDestroyWindow( "finestrablob" );

	if (tracker != NULL) delete(tracker);

	return 0;
}



